#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>

unsigned long t0;
int alarms = 0;

void wakeup(int s) {
  --alarms;
  printf("%lus: Alarme reçue. (%u restantes)\n", time(NULL)-t0, alarms);
}

void set_alarm(int x) {
  if (alarms == 256) return; // pas plus de 256 processus fils en même temps
  if (fork() == 0) { // fils
	 sleep(x);
	 kill(getppid(), SIGUSR1);
	 exit(0);
  } else // père
	 ++alarms;
}

int main(void) {
  signal(SIGUSR1, wakeup);

  t0 = time(NULL);
  set_alarm(3);
  set_alarm(5);
  set_alarm(8);

  while (alarms)
	 pause();

  return 0;
}
